import * as firebase from 'firebase';
import { RxFirebaseAuth, RxFirebaseUser } from './auth';
import { RxFirebaseDatabase, RxFirebaseDatabaseRef, RxFirebaseDatabaseRefOnDisconnect, RxFirebaseDataSnapshot } from './database';
import { RxFirebaseStorage } from './storage';
export declare class RxFirebase {
    private static internalDefault;
    readonly app: firebase.app.App;
    readonly auth: RxFirebaseAuth;
    readonly database: RxFirebaseDatabase;
    readonly storage: RxFirebaseStorage;
    constructor(options: Object, name?: string);
    static readonly auth: RxFirebaseAuth;
    static readonly database: RxFirebaseDatabase;
    static readonly storage: RxFirebaseStorage;
    static readonly name: string;
    static readonly options: Object;
    static initializeApp(options: Object, name?: string): RxFirebase;
    private static ensureDefaultInitialized();
    readonly name: string;
    readonly options: Object;
}
export { firebase, RxFirebaseAuth, RxFirebaseDatabase, RxFirebaseDatabaseRef, RxFirebaseDatabaseRefOnDisconnect, RxFirebaseDataSnapshot, RxFirebaseStorage, RxFirebaseUser };
