"use strict";
var firebase = require("firebase");
exports.firebase = firebase;
var auth_1 = require("./auth");
exports.RxFirebaseAuth = auth_1.RxFirebaseAuth;
var database_1 = require("./database");
exports.RxFirebaseDatabase = database_1.RxFirebaseDatabase;
exports.RxFirebaseDatabaseRef = database_1.RxFirebaseDatabaseRef;
var storage_1 = require("./storage");
exports.RxFirebaseStorage = storage_1.RxFirebaseStorage;
var RxFirebase = (function () {
    function RxFirebase(options, name) {
        this.app = firebase.initializeApp(options, name);
        this.auth = new auth_1.RxFirebaseAuth(this.app);
        this.database = new database_1.RxFirebaseDatabase(this);
        this.storage = new storage_1.RxFirebaseStorage(this.app);
    }
    Object.defineProperty(RxFirebase, "auth", {
        get: function () {
            RxFirebase.ensureDefaultInitialized();
            return RxFirebase.internalDefault.auth;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RxFirebase, "database", {
        get: function () {
            RxFirebase.ensureDefaultInitialized();
            return RxFirebase.internalDefault.database;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RxFirebase, "storage", {
        get: function () {
            RxFirebase.ensureDefaultInitialized();
            return RxFirebase.internalDefault.storage;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RxFirebase, "name", {
        get: function () {
            RxFirebase.ensureDefaultInitialized();
            return RxFirebase.internalDefault.app.name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RxFirebase, "options", {
        get: function () {
            RxFirebase.ensureDefaultInitialized();
            return RxFirebase.internalDefault.app.options;
        },
        enumerable: true,
        configurable: true
    });
    RxFirebase.initializeApp = function (options, name) {
        if ((name === undefined) || (name === '[DEFAULT]')) {
            RxFirebase.internalDefault = new RxFirebase(options);
            return RxFirebase.internalDefault;
        }
        else {
            return new RxFirebase(options, name);
        }
    };
    RxFirebase.ensureDefaultInitialized = function () {
        if (!RxFirebase.internalDefault) {
            throw new Error("RxFirebase hasn't been initialized yet. Call RxFirebase.initializeApp()");
        }
    };
    Object.defineProperty(RxFirebase.prototype, "name", {
        get: function () {
            return this.app.name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RxFirebase.prototype, "options", {
        get: function () {
            return this.app.options;
        },
        enumerable: true,
        configurable: true
    });
    return RxFirebase;
}());
exports.RxFirebase = RxFirebase;
//# sourceMappingURL=RxFirebase.js.map