import * as firebase from 'firebase';
import { Observable } from 'rxjs';
export interface RxFirebaseUser extends firebase.User {
}
export declare class RxFirebaseAuth {
    readonly app: firebase.app.App;
    readonly onAuthStateChanged$: Observable<RxFirebaseUser>;
    readonly onSignIn$: Observable<RxFirebaseUser>;
    readonly onSignOut$: Observable<RxFirebaseUser>;
    readonly isSignedIn$: Observable<boolean>;
    private readonly sdk;
    private readonly initiallySingedOut$;
    private onAuthStateChanged$complete;
    private currentAuth;
    constructor(app: firebase.app.App);
    readonly currentUser: RxFirebaseUser;
    createCustomToken(uid: string, developerClaims?: Object | null): string;
    applyActionCode(code: string): Promise<any>;
    checkActionCode(code: string): Promise<any>;
    confirmPasswordReset(code: string, newPassword: string): Promise<any>;
    createUserWithEmailAndPassword(email: string, password: string): Promise<any>;
    fetchProvidersForEmail(email: string): Promise<any>;
    getRedirectResult(): Promise<any>;
    sendPasswordResetEmail(email: string): Promise<any>;
    signInAnonymously(): Promise<any>;
    signInWithCredential(credential: firebase.auth.AuthCredential): Promise<any>;
    signInWithCustomToken(token: string): Promise<any>;
    signInWithEmailAndPassword(email: string, password: string): Promise<any>;
    signInWithPopup(provider: firebase.auth.AuthProvider): Promise<any>;
    signInWithRedirect(provider: firebase.auth.AuthProvider): Promise<any>;
    signOut(): Promise<any>;
    verifyIdToken(idToken: string): Promise<any>;
    verifyPasswordResetCode(code: string): Promise<any>;
}
