"use strict";
var firebase = require("firebase");
var ref_1 = require("./ref");
var RxFirebaseDatabase = (function () {
    function RxFirebaseDatabase(rxfb) {
        this.rxfb = rxfb;
        this.sdk = firebase.database(this.rxfb.app);
    }
    RxFirebaseDatabase.enableLogging = function (enabled, persistent) {
        firebase.database.enableLogging(enabled, persistent);
    };
    RxFirebaseDatabase.prototype.ref = function (path) {
        return new ref_1.RxFirebaseDatabaseRef(this, { path: path });
    };
    RxFirebaseDatabase.prototype.refFromURL = function (url) {
        return new ref_1.RxFirebaseDatabaseRef(this, { url: url });
    };
    RxFirebaseDatabase.prototype.goOffline = function () {
        this.sdk.goOffline();
    };
    RxFirebaseDatabase.prototype.goOnline = function () {
        this.sdk.goOnline();
    };
    return RxFirebaseDatabase;
}());
RxFirebaseDatabase.ServerValue = firebase.database.ServerValue;
exports.RxFirebaseDatabase = RxFirebaseDatabase;
//# sourceMappingURL=database.js.map