import * as firebase from 'firebase';
import { Observable } from 'rxjs';
import { RxFirebaseDatabase } from './database';
export declare class RxFirebaseDatabaseRef {
    readonly db: RxFirebaseDatabase;
    protected ref: firebase.database.Reference;
    private filters;
    private callback;
    constructor(db: RxFirebaseDatabase, from: {
        path?: string;
        url?: string;
        ref?: firebase.database.Reference;
    });
    private static applyFilter(observable, filter);
    child(path: string): RxFirebaseDatabaseRef;
    readonly parent: RxFirebaseDatabaseRef;
    readonly root: RxFirebaseDatabaseRef;
    readonly key: string | null;
    untilSignIn(): RxFirebaseDatabaseRef;
    untilSignOut(): RxFirebaseDatabaseRef;
    afterSignIn(): RxFirebaseDatabaseRef;
    afterSignOut(): RxFirebaseDatabaseRef;
    getValue(): RxFirebaseDatabaseRef;
    withPrevChildKey(): this;
    asList(): RxFirebaseDatabaseRef;
    onValue(): Observable<any>;
    onChildAdded(): Observable<any>;
    onChildRemoved(): Observable<any>;
    onChildChanged(): Observable<any>;
    onChildMoved(): Observable<any>;
    onceValue(): Observable<any>;
    onceChildAdded(): Observable<any>;
    onceChildRemoved(): Observable<any>;
    onceChildChanged(): Observable<any>;
    onceChildMoved(): Observable<any>;
    startAt(value: number | string | boolean | null, key?: string): RxFirebaseDatabaseRef;
    endAt(value: number | string | boolean | null, key?: string): RxFirebaseDatabaseRef;
    equalTo(value: number | string | boolean | null, key?: string): RxFirebaseDatabaseRef;
    isEqual(other: RxFirebaseDatabaseRef | null): boolean;
    limitToFirst(limit: number): RxFirebaseDatabaseRef;
    limitToLast(limit: number): RxFirebaseDatabaseRef;
    orderByChild(path: string): RxFirebaseDatabaseRef;
    orderByKey(): RxFirebaseDatabaseRef;
    orderByPriority(): RxFirebaseDatabaseRef;
    orderByValue(): RxFirebaseDatabaseRef;
    toString(): string;
    on(eventType: string): Observable<any>;
    once(eventType: string): Observable<any>;
    onDisconnect(): RxFirebaseDatabaseRefOnDisconnect;
    push(value?: any, onComplete?: (err: Error | null) => any): RxFirebaseDatabaseRef;
    remove(onComplete?: (err: Error | null) => any): Promise<any>;
    set(value: any, onComplete?: (err: Error | null) => any): Promise<any>;
    setPriority(priority: string | number | null, onComplete: (err: Error | null) => any): Promise<any>;
    setWithPriority(newVal: any, newPriority: string | number | null, onComplete?: (err: Error | null) => any): Promise<any>;
    transaction(transactionUpdate: (a: any) => any, onComplete?: (err: Error | null, committed: boolean, snapshot: RxFirebaseDataSnapshot | null) => any, applyLocally?: boolean): Promise<any>;
    update(values: Object, onComplete?: (err: Error | null) => any): Promise<any>;
    private applyFilters(observable);
}
export interface RxFirebaseDataSnapshot extends firebase.database.DataSnapshot {
}
export interface RxFirebaseDatabaseRefOnDisconnect extends firebase.database.OnDisconnect {
}
